#!/bin/bash
set -euo pipefail

ACTION="$1"
ALIAS="$2"
FROM="$3"

if [ "$ACTION" == "SIGNUP" ]; then
	TO=postmaster@localhost
	HEADER="X-MEMBER-ALIAS: $ALIAS"
else
	TO=cropswap@shandan.one
	HEADER="X-IGNORED:"
fi

#
# Ideally, FROM should be "postmaster" or "root" or something
# but to keep the logic (at this time) simpler
# I impersonate the user
#
# However, the origin of these e-mails are still disambiguated
# by the "From: " header
maildrop -f "$FROM" <<EOF
From: postmaster@localhost
To: ${TO}
Subject: [${ACTION}]
${HEADER}
EOF
