#!/bin/bash
set -euo pipefail
MAIL="$(cat -)"
echo "${MAIL}" > /home/pi/original

declare -A SUBSCRIBED
declare -a actions
update(){
	da="${actions[$1-1]:0:1}"
        db="${2:0:1}"
	alias="${actions[$1-1]#?}"
	email="${2#?}"
	
	if [ "$da" == "$db" ]; then
		[ "$da" == "+" ] && SUBSCRIBED["$email"]="$alias" || SUBSCRIBED["$email"]=""
	else
		# corrupt list
		exit 1
	fi
}

touch "${SLIST}.txt"
mapfile -t -c 2 -C update actions < "${SLIST}.txt"

(for email in "${!SUBSCRIBED[@]}"; do
	if [ -z "${SUBSCRIBED["$email"]}" ]; then continue; fi
	echo "+$alias"
        echo "+$email"
        if [ "${email,,}" == "${NOFORWARD,,}" ]; then continue; fi
	formail -rkb \
		-A "Reply-to: ${FROM} <cropswap@shandan.one>" \
		-i "MIME-Version:" \
		-i "Content-Type:" \
	<<<"${MAIL}" \
	>> /home/pi/reformail
	#cat /home/pi/reformail | /usr/sbin/sendmail \
	#	-F "${sendr}" \
	#	-f "cropswap@shandan.one" \
	#	-v "${addr}"
done) > "${SLIST}.txt"
#TODO: report errors properly
